/*
 * Filename: "c4i_fundecl.h"; Copyright (c) 1995 VI Corporation
 */
#ifndef __C4I_FUNDECL__
#define __C4I_FUNDECL__

#include "std.h"
#include "dvstd.h"
#include "dvtools.h"
#include "dvinteract.h"

typedef struct _ZOOM_INFO *ZOOM_INFO;

/* Internal function: allocates & copies a string */
CHAR *VIstrclone V_P_((char*));          


/* Functions defined in c4i_dsp.c */
void InitDisplays V_P_((void));
void OverlayDisplay V_P_((char *view_name, int dsl_merge_required));
void RemoveDisplay V_P_((char *view_name));
DRAWPORT Get_Drawport V_P_((char *view_name, OBJECT screen,
			    BOOLPARAM stretch,
			    RECTANGLE *vvp, RECTANGLE *wvp));
void TermDisplays V_P_((void));

/* Functions defined in c4i_dyn.c */
void HandleDynamics V_P_((void));

/* Functions defined in c4i_events.c */
void InitSimpleEvents V_P_((void));
void SetupButtons V_P_((VIEW view));
void HandleEvents V_P_((void));
int HandleWindowEvent V_P_((OBJECT client, EVENT_REQUEST req_id, int event_type, OBJECT loc, ADDRESS args));
int HandlePickEvent V_P_((OBJECT client, EVENT_REQUEST req_id, int pick_type, OBJECT loc, ADDRESS args));
void ParseCommand V_P_((char *cmd, char *buf_ptr, char **p_to_ptr1, char **p_to_ptr2, char **p_to_ptr3));
int GetOverlayId V_P_((char *named));
void FlipButton V_P_((char *name, OBJECT obj, DRAWPORT dp_of_obj));
OBJECT FlipOnlyOneObj V_P_((char *name, OBJECT obj_present, float **p_to_dsv_buf, DRAWPORT dp_of_obj));

/* Functions defined in c4i_model.c */
void InitModel V_P_((void));
void UpdateApplicationModel V_P_((void));

/* Functions defined in c4i_olays.c */
void ReplaceOverlay V_P_((int cmd, char *file_name, char *var_name, char *extra_str));
void MainOverlayToggle V_P_((char *file_name));

/* Functions defined in c4i_popups.c */
void CreatePopupDps V_P_((void));
void ResizeThisPopup V_P_((int p_class));
void ResizePopups V_P_((void));
void RedrawPopups V_P_((BOOLPARAM requested_TdpDraw));

/* Functions defined in c4i_rebind.c */
void InitDataTable V_P_((void));
void RebindData V_P_((VIEW view));
void TermDataTable V_P_((void));
ADDRESS GetVdp V_P_((OBJECT obj));

/* Functions defined in c4i_utils.c */
VIEW Get_View V_P_((char *view_name, BOOLPARAM add_to_requested));
void GetCoords V_P_((DRAWPORT dp, RECTANGLE *dr_vp, RECTANGLE *scr_vp,
		     RECTANGLE *virt_vp));

/* Functions defined in c4i_wins.c */
OBJECT OpenWindow V_P_((int window_id));
void CloseWin V_P_((int window_id));
void CleanupWindow V_P_((int window_id));

/* Functions defined in c4i_zoom.c */
void InitZoomInfo V_P_((void));
void HandleZoomCmd V_P_((void));
void HandleZoomSubCmd V_P_((int cmd));
void VscrollPlease V_P_((ZOOM_INFO info));
void HscrollPlease V_P_((ZOOM_INFO info));

#endif /* __C4I_FUNDECL__ */
